#!/usr/bin/env python
# -*- coding:utf-8 -*-

# ##############################################################################
#     Base code from where the autogenerated code inherits
#
#     Copyright (C) 2021 Alba Synchrotron/CELLS, Cerdanyola Spain
#
#     This program is free software: you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
#
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with this program.  If not, see [http://www.gnu.org/licenses/].
# ##############################################################################


from datetime import datetime
from numpy import array, append
import subprocess
import struck.sis830x
import sys
from time import sleep
import types


# TODO: remove the dry_run to True
# TODO: output of the execution in the ScriptExec


class AbstractInitialization:
    __device = None

    def __init__(self, device=None):
        """
Abstract class made to manage the reference to the tango device from where the
log streams are taken.
        """
        self.__device = device

    @property
    def device(self):
        return self.__device

    @device.setter
    def device(self, value):
        self.__device = value

    def __getattr__(self, item):
        if item in ['error_stream', 'warn_stream', 'info_stream',
                    'debug_stream']:
            def stream_method(_self, msg):
                if self.__device is not None:
                    if self.__device._start_procedure_logs is None:
                        self.__device._start_procedure_logs = array([],
                                                                    dtype='<U1')
                    if msg.count('\n') > 0:
                        self.__device._start_procedure_logs = append(
                            self.__device._start_procedure_logs,
                            msg.split('\n'))
                    else:
                        self.__device._start_procedure_logs = append(
                            self.__device._start_procedure_logs, msg)
                    return getattr(self.__device, item)(msg)
            _method = types.MethodType(stream_method, self)
            return _method
        else:
            raise AttributeError()


class InitializationGroup(list, AbstractInitialization):
    __group_name = None

    def __init__(self, name, *args, **kwargs):
        """
Sorted list of steps to do when apply is called. It can store nested groups or
actions.
        """
        AbstractInitialization.__init__(self, *args, **kwargs)
        self.__group_name = name

    def __str__(self):
        return f"group {self.__group_name}"

    def append(self, item):
        if isinstance(item, InitializationGroup) or \
                isinstance(item, InitializationAction):
            super(InitializationGroup, self).append(item)
            if item.device is None:
                item.device = self.device
        else:
            raise TypeError

    def insert(self, idx, item):
        if isinstance(item, InitializationGroup) or \
                isinstance(item, InitializationAction):
            super(InitializationGroup, self).insert(idx, item)
            if item.device is None:
                item.device = self.device
        else:
            raise TypeError

    def apply(self):
        t_0 = datetime.now()
        for element in self:
            element.apply()
        delta_t = datetime.now()-t_0
        self.debug_stream(f"{self.__group_name} apply() in "
                          f"{delta_t.total_seconds():f} seconds")


class InitializationAction(AbstractInitialization):
    __dry_run = None

    def __init__(self, dry_run=None, *args, **kwargs):
        """
Abstract class for actions to be applied.
        """
        super(InitializationAction, self).__init__(*args, **kwargs)
        self.__dry_run = dry_run or False

    @property
    def dry_run(self):
        return self.__dry_run

    def apply(self):
        raise NotImplementedError


class RegisterWrite(InitializationAction):
    __human_meaning = None
    __device_filename = None
    __register_address = None
    __register_value = None

    def __init__(self, meaning, devfilename, address, value, *args, **kwargs):
        """
Represents the initialization action to write an specific value to an specific
register of a struck card referenced by its name in the /dev/sis*

:param meaning: the string explaining the significant of this action
:param devfilename: string with the filename in /dev/sis*
:param address: register address to write the value
:param value: value to be written in the register of the card
        """
        super(RegisterWrite, self).__init__(*args, **kwargs)
        self.__human_meaning = meaning
        self.__device_filename = devfilename
        self.__register_address = address
        self.__register_value = value

    def __str__(self):
        return f"RegisterWrite({self.__human_meaning}, " \
               f"{self.__device_filename}, {self.__register_address}, " \
               f"{self.__register_value})"

    def apply(self):
        t_0 = datetime.now()
        if self.dry_run:
            sleep(.001)
        else:
            with struck.sis830x.Card(self.__device_filename) as card:
                card.write_register(self.__register_address,
                                    self.__register_value)
        delta_t = datetime.now()-t_0
        self.debug_stream(f"Initialized device={self.__device_filename} "
                          f"register=0x{self.__register_address:03X} "
                          f"value=0x{self.__register_value:08X}: "
                          f"{self.__human_meaning}"
                          f"{' (dry_run)' if self.dry_run else ''}"
                          f" in {delta_t.total_seconds():f} seconds")


class AttributeWrite(InitializationAction):
    __attribute_name = None
    __attribute_value = None

    def __init__(self, name, value, *args, **kwargs):
        """
Represents the initialization action by writing a value to a tango attribute of
the corresponding dllrf device.

:param name: tango attribute name
:param value: value to
        """
        super(AttributeWrite, self).__init__(*args, **kwargs)
        self.__attribute_name = name
        self.__attribute_value = value

    def __str__(self):
        return f"AttributeWrite({self.__attribute_name}, " \
               f"{self.__attribute_value})"

    @property
    def __multiattr_obj(self):
        if self.device is not None:
            return self.device.get_device_attr()

    def apply(self):
        t_0 = datetime.now()
        if self.dry_run:
            sleep(.001)
        else:
            attribute_obj = \
                self.__multiattr_obj.get_attr_by_name(self.__attribute_name)
            attribute_obj.set_write_value(self.__attribute_value)
            self.device.write_Attribute(attribute_obj, self.__attribute_name)
        delta_t = datetime.now()-t_0
        self.debug_stream(f"Initialized attribute={self.__attribute_name} "
                          f"value={self.__attribute_value}"
                          f"{' (dry_run)' if self.dry_run else ''}"
                          f" in {delta_t.total_seconds():f} seconds")


class SystemExecution(InitializationAction):
    __script_name = None
    __script_arguments = None
    __script_working_directory = None

    def __init__(self, target, arguments=None, cwd=None, *args, **kwargs):
        """
Represents the initialization action of a command line execution with some
arguments if they are needed.

:param target: full path and name of the file with execution rights in
               the system
:param arguments: command line arguments to be set in the call
        """
        super(SystemExecution, self).__init__(*args, **kwargs)
        self.__script_name = target
        self.__script_arguments = arguments or []
        self.__script_working_directory = cwd

    def __str__(self):
        args = f", {self.__script_arguments}" \
            if len(self.__script_arguments) > 0 else ""
        return f"ScriptExec({self.__script_name}, {args})"

    def apply(self):
        t_0 = datetime.now()
        if self.dry_run:
            sleep(2.5)
        else:
            if self.__script_working_directory is None:
                answer = subprocess.run(
                    [self.__script_name] + self.__script_arguments,
                    capture_output=True)
            else:
                answer = subprocess.run(
                    [self.__script_name]+self.__script_arguments,
                    capture_output=True, cwd=self.__script_working_directory)
            if len(answer.stdout) > 0:
                self.debug_stream(f"{self.__script_name} strout:\n"
                                  f"{answer.stdout.decode()}")
            if len(answer.stderr) > 0:
                self.debug_stream(f"{self.__script_name} strerr:\n"
                                  f"{answer.stderr.decode()}")
            if answer.returncode != 0:
                self.error_stream(f"{self.__script_name} ends with code "
                                  f"{answer.returncode}")
        delta_t = datetime.now()-t_0
        self.debug_stream(f"Launched the script {self.__script_name!r} "
                          f"with arguments {self.__script_arguments!r}"
                          f"{' (dry_run)' if self.dry_run else ''}"
                          f" in {delta_t.total_seconds():f} seconds")


def fpga_initialization_procedure(device):
    main = InitializationGroup("main", device=device)
    first = InitializationGroup("Port 12 Communication enable")
    main.append(first)
    first.append(RegisterWrite("Disable port 12&13 backplane communication",
                               "/dev/sis8864-0", 0x4, 0x30000000))
    first.append(RegisterWrite("DIO output from Backplane port 12",
                               "/dev/sis8864-0", 0x10E, 0x33333333))
    first.append(RegisterWrite("Enable port12 backplane communication",
                               "/dev/sis8864-0", 0x4, 0x1000))
    first.append(RegisterWrite("DIO1 output and DIO2 input",
                               "/dev/sis8864-0", 0x100, 0xF0000F))
    first.append(SystemExecution(
        "/home/alba/SIS/sis8300KU_tests/sfp-port-link-tests/init_mgt_clks"))
    first.append(SystemExecution(
        "./bin/Debug/port_link_test",
        arguments=["/dev/sis8300-s4", "0x1"],
        cwd="/home/alba/SIS/sis8300KU_tests/port_link_test"))
    second = InitializationGroup("VCXO programming")
    main.append(second)
    second.append(AttributeWrite("Mux0_Divider", 1))
    second.append(AttributeWrite("Mux1_Divider", 4))
    second.append(AttributeWrite("Y0enable", 1))
    second.append(AttributeWrite("Y1enable", 1))
    second.append(AttributeWrite("VCXO_Outputs_enable", 1))
    second.append(AttributeWrite("Send_Word", 0))
    second.append(AttributeWrite("Send_Word", 1))
    second.append(AttributeWrite("Send_Word", 0))
    third = InitializationGroup("Set external clock")
    main.append(third)
    third.append(RegisterWrite("Front panel SMA clock",
                               "/dev/sis8300-0", 0x40, 0xF0F))
    third.append(RegisterWrite("DAC set to complement 2",
                               "/dev/sis8300-0", 0x45, 0x10))
    main.apply()
